import * as _vuepress_core from '@vuepress/core';
import { Plugin } from '@vuepress/core';
import { DocgenCLIConfig, Templates } from 'vue-docgen-cli';
import { ComponentDoc } from 'vue-docgen-api';
import { GrayMatterOption } from 'gray-matter';

declare module '@vuepress/core' {
    interface PageOptions {
        isDocgenPage?: boolean;
    }
}
type UsedInVueDocgenConfigProcessingProperties = 'docsBranch' | 'docsRepo' | 'docsFolder';
interface VueDocgenPluginGroup {
    root?: string;
    components: string | string[];
    outDir?: string;
    docgenCliConfig?: Partial<Omit<DocgenCLIConfig, 'outDir' | UsedInVueDocgenConfigProcessingProperties> & Record<UsedInVueDocgenConfigProcessingProperties, never>>;
}
interface VueDocgenPluginOptions {
    docgenCliConfig?: Partial<Omit<DocgenCLIConfig, 'outDir' | 'components' | UsedInVueDocgenConfigProcessingProperties> & Record<UsedInVueDocgenConfigProcessingProperties, never>>;
    docgenCliConfigPath?: string;
    groups?: string | string[] | VueDocgenPluginGroup[];
    stateless?: boolean;
}

declare const VueDocgenPlugin: ({ docgenCliConfig, docgenCliConfigPath, groups, stateless, }: VueDocgenPluginOptions) => Plugin<_vuepress_core.PluginObject>;

declare const extractAndCutFrontmatter: (doc: Partial<Pick<ComponentDoc, 'docsBlocks'>>, grayMatterOptions: GrayMatterOption<any, any>, content?: string) => {
    content: string;
    frontmatter: Record<any, any>;
};

declare const _default: (grayMatterOptions: GrayMatterOption<any, any>) => Templates['component'];

export { UsedInVueDocgenConfigProcessingProperties, VueDocgenPlugin, VueDocgenPluginGroup, VueDocgenPluginOptions, extractAndCutFrontmatter, _default as templateComponent };
